#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

if [ $# -eq 0 ]
then
	print_version
	echo 1>&2
	print_usage
	CLEANEXIT=1
	exit 0
fi

if [ $# -ne 2 ]
then
	print_usage;
	CLEANEXIT=1
	exit 1
fi

# Log into mysql as user running script, not hfgen
echo "drop database if exists $2; create database $2; commit;" | \
mysql --line-numbers --show-warnings --skip-pager -vvv

mysqldump "$1" | \
mysql --line-numbers --show-warnings --skip-pager -vvv "$2"
