#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

HFGENDB=${HFGENDB:-hfexample1}

if [ "${1:-}" != '-y' ]
then
	echo "Press RET to drop and reload database '$HFGENDB', or ^C to cancel"
	CLEANEXIT=1
	read DUMMY
	CLEANEXIT=0
fi

# Log into mysql as user running script, not hfgen
mysql --line-numbers --show-warnings --skip-pager -vvv mysql << EOF
drop database if exists $HFGENDB;
create database $HFGENDB;
commit;
EOF

# Log into mysql as user running script, not hfgen
(
# for speed
echo "set autocommit=0;"
cat /@@@ HFTOP @@@/lib/ddl.sql
echo "commit;"
) | mysql --line-numbers --show-warnings --skip-pager -vvv $HFGENDB

# Log into mysql as user running script, not hfgen
(
# for speed
echo "set autocommit=0;"
cat /@@@ HFTOP @@@/lib/load.sql
echo "commit;"
) | mysql --line-numbers --show-warnings --skip-pager -vvv $HFGENDB
