#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

HFPREFIX='/@@@ HFPREFIX @@@'
HFMAJLINK='@@@ HFMAJLINK @@@'

if [ -t 1 ]
then
	echo "FATAL stdout should not go to terminal, quitting" 1>&2
	print_usage
	CLEANEXIT=1
	exit 1
fi

echo '[ \( -n "$shell" \) -o \( "$SHELL" != /bin/bash \) ] && echo FATAL shell on remote is not bash, quitting && exit 1'
cat << EOF
exec 2>&1
set  -xeuET
mkdir -p $HFPREFIX
rm -f $HFPREFIX/$HFMAJLINK
cd $HFPREFIX
tar -xvpf -
EOF
(cd $HFPREFIX ; tar -cf - .)
