#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

$HF::Globals::hfver = '@@@ HFVER @@@';

# -----

my $filecontents;

if ($ARGV[0] eq '-b') {
	shift (@ARGV);
	open (BASH, "| /bin/bash -e -s") || die "$!";
	print BASH "set +x\n";
	while (<>) {
		# XXX doesn't actually work because $'a\000b' in bash produces
		# XXX "a" only, not NUL or "b"
		print BASH "echo -nE " . $_;
	}
	close (BASH);
} else {
	{
		local ($/);
		while ($filecontents = <>) {
			print HF::Encode->decode ($filecontents);
		}
	}
}

exit (0);
