#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

if [ "${1:-}" = '-d' ]
then
	DODU=1
	shift
else
	DODU=0
fi

if [ -z "${1:-}" ]
then
	set -- '*' '.*'
fi

if [ $DODU -eq 1 ]
then
	LOG=/tmp/hfdu-$$.log
	hflayers globnull "$@" | (hfdist -v 3 -l - -x 22 -O $LOG > /dev/null || :)
	hflog -x $LOG
	rm -f $LOG
else
	hflayers globnull "$@" | \
		awk '/^.source_layers/, /^.target_layers/ { gsub(/\[0\]/, "[101]") } { print }' | \
		(hfdist -v 5 -l - > /dev/null || :)
fi
