#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

if [ "${1:-}" = '-k' ]
then
	OPTK='-k'
	shift
else
	OPTK=''
fi

if [ $# -ne 2 ]
then
	print_version
	echo 1>&2
	print_usage
	CLEANEXIT=1
	exit 0
fi

/@@@ HFTOP @@@/bin/sl $OPTK "$1" > /tmp/sl-diff-1.$$
/@@@ HFTOP @@@/bin/sl $OPTK "$2" > /tmp/sl-diff-2.$$

DIFFRESULT="0"
diff /tmp/sl-diff-[12].$$ || DIFFRESULT="$?"

rm /tmp/sl-diff-[12].$$

CLEANEXIT=1
exit $DIFFRESULT
