#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

my @inargs;
my @hostlist;
my $i;

if ($ENV{HFGENDB} eq "") {
	$ENV{HFGENDB} = '@@@ EXAMPLEDB @@@';
}

if (-d 'hfgen.out') {
	$main::hfhostlists = "hfgen.out/$ENV{HFGENDB}/hostlists";
} else {
	$main::hfhostlists = "/@@@ HFTOP @@@/gen/hfgen.out/$ENV{HFGENDB}/hostlists";
}

if (!(-d $main::hfhostlists)) {
	die "FATAL host list dir does not exist: $main::hfhostlists, quitting\n";
}

if (!(defined ($ARGV[0]))) {
	warn "# STATUS these hostlists are in $main::hfhostlists\n";
###	$ENV{"LANG"} = "C"; 
	(!(system ('/bin/ls', '-1', $main::hfhostlists) / 256)) || die "FATAL can't ls $main::hfhostlists with error $!, quitting";
	exit (0);
}

@inargs = @ARGV;

@hostlist = &HF::Misc::dosetmath (@inargs);

foreach $i (@hostlist) {
	print "$i\n";
}

exit (0);
