
sub touch {

	$filename = shift;
	$contents = shift;

	$filename =~ s#^(\s)#./$1#;
	open (TOUCH, '>', "$filename\0") || die "$!, filename $filename";
	if (defined ($contents)) {
		print TOUCH $contents;
	}
	close (TOUCH) || die "$!";
	chmod (0644, $filename) || die "$!";
	utime (1000000000, 1000000000, $filename) || die "$!";
}

(!(system ('rm', '-rf', 't_hflog_rsync', 't_hflog_rsync2') / 256)) || die "$!";
mkdir ('t_hflog_rsync', 0755) || die "$!";
mkdir ('t_hflog_rsync2', 0755) || die "$!";

#  create
#	create-file

&touch ('t_hflog_rsync/create-file');
utime (1000000000, 1000000000, 't_hflog_rsync/create-file') || die "$!";

#	create-dir

mkdir ('t_hflog_rsync/create-dir', 0755) || die "$!";
utime (1000000000, 1000000000, 't_hflog_rsync/create-dir') || die "$!";

#	create-symlink

symlink ('create-file', 't_hflog_rsync/create-symlink') || die "$!";

#  delete
#	delete-file

&touch ('t_hflog_rsync2/delete-file');
utime (1000000000, 1000000000, 't_hflog_rsync2/delete-file') || die "$!";

#	delete-dir

mkdir ('t_hflog_rsync2/delete-dir', 0755) || die "$!";
utime (1000000000, 1000000000, 't_hflog_rsync2/delete-dir') || die "$!";

#	delete-symlink

symlink ('create-file', 't_hflog_rsync2/delete-symlink') || die "$!";

#  relink
#	relink-file

&touch ('t_hflog_rsync/relink-file');
utime (1000000000, 1000000000, 't_hflog_rsync/relink-file') || die "$!";
link ('t_hflog_rsync/relink-file', 't_hflog_rsync/relink-file2') || die "$!";
# XXX can't test relink fully, rsync doesn't mutate hardlinks fully
### link ('t_hflog_rsync/relink-file', 't_hflog_rsync/relink-file4') || die "$!";
### &touch ('t_hflog_rsync/relink-file3');
### utime (1000000000, 1000000000, 't_hflog_rsync/relink-file3') || die "$!";
&touch ('t_hflog_rsync/relink-file5');
utime (1000000000, 1000000000, 't_hflog_rsync/relink-file5') || die "$!";
&touch ('t_hflog_rsync2/relink-file');
utime (1000000000, 1000000000, 't_hflog_rsync2/relink-file') || die "$!";
&touch ('t_hflog_rsync2/relink-file2');
utime (1000000000, 1000000000, 't_hflog_rsync2/relink-file2') || die "$!";
link ('t_hflog_rsync2/relink-file', 't_hflog_rsync2/relink-file3') || die "$!";
link ('t_hflog_rsync2/relink-file', 't_hflog_rsync2/relink-file4') || die "$!";
link ('t_hflog_rsync2/relink-file2', 't_hflog_rsync2/relink-file5') || die "$!";
link ('t_hflog_rsync2/relink-file2', 't_hflog_rsync2/relink-file6') || die "$!";

#	relink-char

if ($> == 0) {
	(!(system ('mknod', 't_hflog_rsync/relink-char', 'c', '1', '1') / 256)) || die "$!";
	utime (1000000000, 1000000000, 't_hflog_rsync/relink-char') || die "$!";
	link ('t_hflog_rsync/relink-char', 't_hflog_rsync/relink-char2') || die "$!";
# XXX can't test relink fully, rsync doesn't mutate hardlinks fully
###	link ('t_hflog_rsync/relink-char', 't_hflog_rsync/relink-char4') || die "$!";
###	(!(system ('mknod', 't_hflog_rsync/relink-char3', 'c', '1', '1') / 256)) || die "$!";
###	utime (1000000000, 1000000000, 't_hflog_rsync/relink-char3') || die "$!";
	(!(system ('mknod', 't_hflog_rsync/relink-char5', 'c', '1', '1') / 256)) || die "$!";
	utime (1000000000, 1000000000, 't_hflog_rsync/relink-char5') || die "$!";
	(!(system ('mknod', 't_hflog_rsync2/relink-char', 'c', '1', '1') / 256)) || die "$!";
	utime (1000000000, 1000000000, 't_hflog_rsync2/relink-char') || die "$!";
	(!(system ('mknod', 't_hflog_rsync2/relink-char2', 'c', '1', '1') / 256)) || die "$!";
	utime (1000000000, 1000000000, 't_hflog_rsync2/relink-char2') || die "$!";
	link ('t_hflog_rsync2/relink-char', 't_hflog_rsync2/relink-char3') || die "$!";
	link ('t_hflog_rsync2/relink-char', 't_hflog_rsync2/relink-char4') || die "$!";
	link ('t_hflog_rsync2/relink-char2', 't_hflog_rsync2/relink-char5') || die "$!";
	link ('t_hflog_rsync2/relink-char2', 't_hflog_rsync2/relink-char6') || die "$!";
}

#  replace
#  	type
#  		replace-type-file1 -> replace-type-dir1

&touch ('t_hflog_rsync/replace-type-file1');
utime (1000000000, 1000000000, 't_hflog_rsync/replace-type-file1') || die "$!";
mkdir ('t_hflog_rsync2/replace-type-dir1', 0755) || die "$!";
utime (1000000000, 1000000000, 't_hflog_rsync2/replace-type-dir1') || die "$!";

#  		replace-type-dir2/contents -> replace-type-file2

mkdir ('t_hflog_rsync/replace-type-dir2', 0755) || die "$!";
utime (1000000000, 1000000000, 't_hflog_rsync/replace-type-dir2') || die "$!";
&touch ('t_hflog_rsync2/replace-type-file2');
utime (1000000000, 1000000000, 't_hflog_rsync2/replace-type-file2') || die "$!";

#  		replace-type-file3 -> replace-type-symlink3

&touch ('t_hflog_rsync/replace-type-file3');
utime (1000000000, 1000000000, 't_hflog_rsync/replace-type-file3') || die "$!";
symlink ('baz', 't_hflog_rsync2/replace-type-symlink3') || die "$!";

#  		replace-type-symlink4 -> replace-type-file4

symlink ('quux', 't_hflog_rsync/replace-type-symlink4') || die "$!";
&touch ('t_hflog_rsync2/replace-type-file4');
utime (1000000000, 1000000000, 't_hflog_rsync2/replace-type-file4') || die "$!";

#  		replace-type-symlink5 -> replace-type-dir5

symlink ('quux', 't_hflog_rsync/replace-type-symlink5') || die "$!";
mkdir ('t_hflog_rsync2/replace-type-dir5', 0755) || die "$!";
utime (1000000000, 1000000000, 't_hflog_rsync2/replace-type-dir5') || die "$!";

#  		replace-type-dir6/contents -> replace-type-symlink6

mkdir ('t_hflog_rsync/replace-type-dir6', 0755) || die "$!";
utime (1000000000, 1000000000, 't_hflog_rsync/replace-type-dir6') || die "$!";
symlink ('quux', 't_hflog_rsync2/replace-type-symlink5') || die "$!";

#  	target
#  		replace-target-symlink

symlink ('foo', 't_hflog_rsync/replace-target-symlink') || die "$!";
symlink ('bar', 't_hflog_rsync2/replace-target-symlink') || die "$!";

#  	checksum
#  		replace-checksum-file

&touch ('t_hflog_rsync/replace-checksum-file', 'abc');
utime (1000000000, 1000000000, 't_hflog_rsync/replace-checksum-file') || die "$!";
&touch ('t_hflog_rsync2/replace-checksum-file', 'def');
utime (1000000000, 1000000000, 't_hflog_rsync2/replace-checksum-file') || die "$!";

#  	mtime
#  		replace-mtime-file

&touch ('t_hflog_rsync/replace-mtime-file', 'abc');
utime (1000000000, 1000000000, 't_hflog_rsync/replace-mtime-file') || die "$!";
&touch ('t_hflog_rsync2/replace-mtime-file', 'abc');
utime (1111111111, 1111111111, 't_hflog_rsync2/replace-mtime-file') || die "$!";

#  	mtime+size
#  		replace-mtime+size-file

&touch ('t_hflog_rsync/replace-mtime+size-file', 'abc');
utime (1000000000, 1000000000, 't_hflog_rsync/replace-mtime+size-file') || die "$!";
&touch ('t_hflog_rsync2/replace-mtime+size-file', 'abcdef');
utime (1111111111, 1111111111, 't_hflog_rsync2/replace-mtime+size-file') || die "$!";

#  	mtime+checksum
#  		replace-mtime+checksum-file

&touch ('t_hflog_rsync/replace-mtime+checksum-file', 'abc');
utime (1000000000, 1000000000, 't_hflog_rsync/replace-mtime+checksum-file') || die "$!";
&touch ('t_hflog_rsync2/replace-mtime+checksum-file', 'def');
utime (1111111111, 1111111111, 't_hflog_rsync2/replace-mtime+checksum-file') || die "$!";

#  	rdev
#  		replace-rdev-char

if ($> == 0) {
	(!(system ('mknod', 't_hflog_rsync/replace-rdev-char', 'c', '1', '1') / 256)) || die "$!";
	utime (1000000000, 1000000000, 't_hflog_rsync/replace-rdev-char') || die "$!";
	(!(system ('mknod', 't_hflog_rsync2/replace-rdev-char', 'c', '2', '2') / 256)) || die "$!";
	utime (1000000000, 1000000000, 't_hflog_rsync2/replace-rdev-char') || die "$!";
}

#  	size
#  		replace-size-file

&touch ('t_hflog_rsync/replace-size-file', 'abc');
utime (1000000000, 1000000000, 't_hflog_rsync/replace-size-file') || die "$!";
&touch ('t_hflog_rsync2/replace-size-file', 'abcdef');
utime (1000000000, 1000000000, 't_hflog_rsync/replace-size-file') || die "$!";

#  fix
#  	owner
#		fix-owner-file

if ($> == 0) {
	&touch ('t_hflog_rsync/fix-owner-file');
	chown (0, 0, 't_hflog_rsync/fix-owner-file') || die "$!";
	utime (1000000000, 1000000000, 't_hflog_rsync/fix-owner-file') || die "$!";
	&touch ('t_hflog_rsync2/fix-owner-file');
	chown (1, 0, 't_hflog_rsync2/fix-owner-file') || die "$!";
	utime (1000000000, 1000000000, 't_hflog_rsync2/fix-owner-file') || die "$!";
}

#		fix-owner-dir

if ($> == 0) {
	mkdir ('t_hflog_rsync/fix-owner-dir', 0755) || die "$!";
	chown (0, 0, 't_hflog_rsync/fix-owner-file') || die "$!";
	utime (1000000000, 1000000000, 't_hflog_rsync/fix-owner-file') || die "$!";
	mkdir ('t_hflog_rsync2/fix-owner-dir', 0755) || die "$!";
	chown (1, 0, 't_hflog_rsync2/fix-owner-file') || die "$!";
	utime (1000000000, 1000000000, 't_hflog_rsync2/fix-owner-file') || die "$!";
}

#  	group
#		fix-group-file

if ($> == 0) {
	&touch ('t_hflog_rsync/fix-group-file');
	chown (0, 0, 't_hflog_rsync/fix-group-file') || die "$!";
	utime (1000000000, 1000000000, 't_hflog_rsync/fix-group-file') || die "$!";
	&touch ('t_hflog_rsync2/fix-group-file');
	chown (0, 1, 't_hflog_rsync2/fix-group-file') || die "$!";
	utime (1000000000, 1000000000, 't_hflog_rsync2/fix-group-file') || die "$!";
}

#		fix-group-dir

if ($> == 0) {
	mkdir ('t_hflog_rsync/fix-group-dir', 0755) || die "$!";
	chown (0, 0, 't_hflog_rsync/fix-group-file') || die "$!";
	utime (1000000000, 1000000000, 't_hflog_rsync/fix-group-file') || die "$!";
	mkdir ('t_hflog_rsync2/fix-group-dir', 0755) || die "$!";
	chown (1, 1, 't_hflog_rsync2/fix-group-file') || die "$!";
	utime (1000000000, 1000000000, 't_hflog_rsync2/fix-group-file') || die "$!";
}

#  	mtime
#		fix-mtime-file

&touch ('t_hflog_rsync/fix-mtime-file', 'abc');
utime (1000000000, 1000000000, 't_hflog_rsync/fix-mtime-file') || die "$!";
&touch ('t_hflog_rsync2/fix-mtime-file', 'abc');
utime (1111111111, 1111111111, 't_hflog_rsync2/fix-mtime-file') || die "$!";

#		fix-mtime-dir

mkdir ('t_hflog_rsync/fix-mtime-dir', 0755) || die "$!";
utime (1000000000, 1000000000, 't_hflog_rsync/fix-mtime-dir') || die "$!";
mkdir ('t_hflog_rsync2/fix-mtime-dir', 0755) || die "$!";
utime (1111111111, 1111111111, 't_hflog_rsync2/fix-mtime-dir') || die "$!";

#  	perms
#		fix-perms-file

&touch ('t_hflog_rsync/fix-perms-file');
chmod (0644, 't_hflog_rsync/fix-perms-file') || die "$!";
utime (1000000000, 1000000000, 't_hflog_rsync/fix-perms-file') || die "$!";
&touch ('t_hflog_rsync2/fix-perms-file');
chmod (0755, 't_hflog_rsync2/fix-perms-file') || die "$!";
utime (1000000000, 1000000000, 't_hflog_rsync2/fix-perms-file') || die "$!";

#		fix-perms-dir

mkdir ('t_hflog_rsync/fix-perms-dir', 0755) || die "$!";
chmod (0755, 't_hflog_rsync/fix-perms-dir') || die "$!";
utime (1000000000, 1000000000, 't_hflog_rsync/fix-perms-dir') || die "$!";
mkdir ('t_hflog_rsync2/fix-perms-dir', 0755) || die "$!";
chmod (0711, 't_hflog_rsync2/fix-perms-dir') || die "$!";
utime (1000000000, 1000000000, 't_hflog_rsync2/fix-perms-dir') || die "$!";

#

utime (1000000000, 1000000000, 't_hflog_rsync') || die "$!";
utime (1000000000, 1000000000, 't_hflog_rsync2') || die "$!";

exit (0);
