
#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

#  Usage:
#
#	mkt_wantbelow

sub chownifroot {

	my $owner = shift;
	my $group = shift;
	my $filename = shift;

	if ($> == 0) {
		return (chown ($owner, $group, $filename));
	} else {
		return (1);
	}
}

sub touch {

	$filename = shift;
	$contents = shift;

	$filename =~ s#^(\s)#./$1#;
	open (TOUCH, '>', "$filename\0") || die "$!, filename $filename";
	if (defined ($contents)) {
		print TOUCH $contents || die "$!";
	}
	close (TOUCH) || die "$!";
	&chownifroot (0, 0, $filename) || die "$!";
	chmod (0644, $filename) || die "$!";
	utime (1000000000, 1000000000, $filename) || die "$!";
}

if (1) {

	(!(system ('rm', '-rf', 't_wantbelow', 't_wantbelow2') / 256)) || die "$!";
	mkdir ('t_wantbelow', 0755) || die "$!";
	&chownifroot (0, 0, 't_wantbelow') || die "$!";
	mkdir ('t_wantbelow2', 0755) || die "$!";
	&chownifroot (0, 0, 't_wantbelow2') || die "$!";
	mkdir ('t_wantbelow/etc', 0755) || die "$!";
	&chownifroot (0, 0, 't_wantbelow/etc') || die "$!";
	mkdir ('t_wantbelow/etc/inet.d', 0755) || die "$!";
	&chownifroot (0, 0, 't_wantbelow/etc/inet.d') || die "$!";
	&touch ('t_wantbelow/etc/inet.d/foo', "put some contents in the file\n");
	chmod (0644, 't_wantbelow/etc/inet.d/foo') || die "$!";
	mkdir ('t_wantbelow2/etc', 0755) || die "$!";
	&chownifroot (0, 0, 't_wantbelow2/etc') || die "$!";
	mkdir ('t_wantbelow2/var', 0755) || die "$!";
	&chownifroot (0, 0, 't_wantbelow2/var') || die "$!";
	mkdir ('t_wantbelow2/var/log', 0755) || die "$!";
	&chownifroot (0, 0, 't_wantbelow2/var/log') || die "$!";
	mkdir ('t_wantbelow2/var/log/apache', 0755) || die "$!";
	&chownifroot (0, 0, 't_wantbelow2/var/log/apache') || die "$!";
	mkdir ('t_wantbelow2/var/log/cups', 0755) || die "$!";
	&chownifroot (0, 0, 't_wantbelow2/var/log/cups') || die "$!";

	utime (1000100000, 1000100000, 't_wantbelow/etc/inet.d/foo') || die "$!";
	utime (1000100000, 1000100000, 't_wantbelow/etc/inet.d') || die "$!";
	utime (1000100000, 1000100000, 't_wantbelow/etc') || die "$!";
	utime (1000100000, 1000100000, 't_wantbelow') || die "$!";
	utime (1000000000, 1000000000, 't_wantbelow2/var/log/apache') || die "$!";
	utime (1000000000, 1000000000, 't_wantbelow2/var/log/cups') || die "$!";
	utime (1000000000, 1000000000, 't_wantbelow2/var/log') || die "$!";
	utime (1000000000, 1000000000, 't_wantbelow2/var') || die "$!";
	utime (1000000000, 1000000000, 't_wantbelow2/etc') || die "$!";
	utime (1000000000, 1000000000, 't_wantbelow2') || die "$!";
}
