
#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

use lib '/@@@ USE LIB @@@';
use HF::HF;

# make HF::Report->report work
$HF::Globals::islocal = 1;
$HF::Globals::verbosity = 20;

@are_ok = (
'/',
'/foo',
'/foo/bar',
'foo',
'foo..',
'foo...',
'.foo',
'..foo',
'...foo',
'/..foo',
'foo.bar',
'foo..bar',
'foo/.bar',
'foo/..bar',
'foo../bar',
'/foo.bar',
'/foo..bar',
'/foo/.bar',
'/foo/..bar',
'/foo../bar'
);

foreach $i (@are_ok) {
	if (!(&HF::Layers::path_is_clean ($i))) {
		die "FAILED wrong result for '$i'\n";
	}
@not_ok = (
'foo/',
'/foo/',
'/foo/bar/',
'.',
'./foo',
'./foo/',
'../foo',
'../../foo',
'/../foo',
'foo/..',
'foo/../',
'//',
'///',
'/..',
'/../foo',
'foo/../bar'
);

}

foreach $i (@not_ok) {
	if (&HF::Layers::path_is_clean ($i)) {
		die "FAILED wrong result for '$i'\n";
	}
}
