#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

echo '%  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew'

# Sort by command name one dir in: "a/hfdist.pod b/coprocess.pod" becomes "b/coprocess.pod a/hfdist.pod"

for i in $((for j ; do echo $j ; done) | sort -t/ -k2,2 | sed 's/\.5*pod//')
do
	DI=$(dirname $i)
	BI=$(basename $i)
	(cd $DI ; pod2latex -sections 'NAME|SYNOPSIS|DESCRIPTION|OPTIONS|FILES|ENVIRONMENT|EXAMPLE|EXIT STATUS|RETURN VALUE|SECURITY|BUGS' -h1level 3 -out ${BI}_tmp $BI.pod)
	echo -e "\n\subsection{$BI}\n"
	sed -e 's/\\label{[A-Z_][A-Z_]*}//g' -e 's/\\index{[A-Z[:space:]][A-Z[:space:]]*}//g' ${i}_tmp.tex
	rm ${i}_tmp.tex
done
