#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

demo_OTHERS := \
	demo/demo.sh \
	demo/dopush \
	demo/GNUmakefile \
	demo/initial-pull.hflayers \
	demo/module.mk \
	demo/push.hflayers \
	demo/vagrant-ssh

demo_SOURCES := \
	$(demo_RESULTS) \
	$(demo_OTHERS)

demo_BASH_TESTME :=

demo_PERL_TESTME :=

demo_BASH_RESULTS := \
	demo/demo.sh \
	demo/dopush \
	demo/vagrant-ssh

demo_PERL_RESULTS :=

demo_RESULTS := \
	$(demo_BASH_RESULTS) \
	$(demo_PERL_RESULTS) \
	demo/initial-pull.hflayers \
	demo/push.hflayers

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
demo/md5:
	cat $(demo_SOURCES) | md5sum | awk '{print $$1}' > demo/md5

.PHONY: build_demo
build_demo: $(demo_RESULTS) demo/md5 ## Build demo

.PHONY: clean_demo
clean_demo: ## Clean demo
	rm -f demo/md5

.PHONY: install_demo
install_demo: installstep1 $(demo_RESULTS) demo/md5 ## Install demo
	cp -a $(demo_RESULTS) install/$(HFBULKTOP)/demo
	ln -s dopush install/$(HFBULKTOP)/demo/dopull
