#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

package HF::Encode;
use strict;

sub encodesetup {

	$HF::Encode::quotearray[0] = '\000';
	$HF::Encode::quotearray[1] = '\001';
	$HF::Encode::quotearray[2] = '\002';
	$HF::Encode::quotearray[3] = '\003';
	$HF::Encode::quotearray[4] = '\004';
	$HF::Encode::quotearray[5] = '\005';
	$HF::Encode::quotearray[6] = '\006';
	$HF::Encode::quotearray[7] = '\007';
	$HF::Encode::quotearray[8] = '\010';
	$HF::Encode::quotearray[9] = '\011';
	$HF::Encode::quotearray[10] = '\012';
	$HF::Encode::quotearray[11] = '\013';
	$HF::Encode::quotearray[12] = '\014';
	$HF::Encode::quotearray[13] = '\015';
	$HF::Encode::quotearray[14] = '\016';
	$HF::Encode::quotearray[15] = '\017';
	$HF::Encode::quotearray[16] = '\020';
	$HF::Encode::quotearray[17] = '\021';
	$HF::Encode::quotearray[18] = '\022';
	$HF::Encode::quotearray[19] = '\023';
	$HF::Encode::quotearray[20] = '\024';
	$HF::Encode::quotearray[21] = '\025';
	$HF::Encode::quotearray[22] = '\026';
	$HF::Encode::quotearray[23] = '\027';
	$HF::Encode::quotearray[24] = '\030';
	$HF::Encode::quotearray[25] = '\031';
	$HF::Encode::quotearray[26] = '\032';
	$HF::Encode::quotearray[27] = '\033';
	$HF::Encode::quotearray[28] = '\034';
	$HF::Encode::quotearray[29] = '\035';
	$HF::Encode::quotearray[30] = '\036';
	$HF::Encode::quotearray[31] = '\037';
	$HF::Encode::quotearray[32] = '\040';

	$HF::Encode::quotearray[34] = '\042';	# added to pass perl eval
	$HF::Encode::quotearray[35] = '\043';	# added to pass perl eval
	$HF::Encode::quotearray[36] = '\044';	# added to pass perl eval
	$HF::Encode::quotearray[37] = '\045';	# added to pass perl eval
	$HF::Encode::quotearray[38] = '\046';	# added to pass perl eval
	$HF::Encode::quotearray[39] = '\047';	# added to pass perl eval

	$HF::Encode::quotearray[64] = '\100';	# added to pass perl eval

	$HF::Encode::quotearray[92] = '\134';

	$HF::Encode::quotearray[96] = '\140';	# added to pass perl eval

	$HF::Encode::quotearray[127] = '\177';
	$HF::Encode::quotearray[128] = '\200';
	$HF::Encode::quotearray[129] = '\201';
	$HF::Encode::quotearray[130] = '\202';
	$HF::Encode::quotearray[131] = '\203';
	$HF::Encode::quotearray[132] = '\204';
	$HF::Encode::quotearray[133] = '\205';
	$HF::Encode::quotearray[134] = '\206';
	$HF::Encode::quotearray[135] = '\207';
	$HF::Encode::quotearray[136] = '\210';
	$HF::Encode::quotearray[137] = '\211';
	$HF::Encode::quotearray[138] = '\212';
	$HF::Encode::quotearray[139] = '\213';
	$HF::Encode::quotearray[140] = '\214';
	$HF::Encode::quotearray[141] = '\215';
	$HF::Encode::quotearray[142] = '\216';
	$HF::Encode::quotearray[143] = '\217';
	$HF::Encode::quotearray[144] = '\220';
	$HF::Encode::quotearray[145] = '\221';
	$HF::Encode::quotearray[146] = '\222';
	$HF::Encode::quotearray[147] = '\223';
	$HF::Encode::quotearray[148] = '\224';
	$HF::Encode::quotearray[149] = '\225';
	$HF::Encode::quotearray[150] = '\226';
	$HF::Encode::quotearray[151] = '\227';
	$HF::Encode::quotearray[152] = '\230';
	$HF::Encode::quotearray[153] = '\231';
	$HF::Encode::quotearray[154] = '\232';
	$HF::Encode::quotearray[155] = '\233';
	$HF::Encode::quotearray[156] = '\234';
	$HF::Encode::quotearray[157] = '\235';
	$HF::Encode::quotearray[158] = '\236';
	$HF::Encode::quotearray[159] = '\237';
	$HF::Encode::quotearray[160] = '\240';
	$HF::Encode::quotearray[161] = '\241';
	$HF::Encode::quotearray[162] = '\242';
	$HF::Encode::quotearray[163] = '\243';
	$HF::Encode::quotearray[164] = '\244';
	$HF::Encode::quotearray[165] = '\245';
	$HF::Encode::quotearray[166] = '\246';
	$HF::Encode::quotearray[167] = '\247';
	$HF::Encode::quotearray[168] = '\250';
	$HF::Encode::quotearray[169] = '\251';
	$HF::Encode::quotearray[170] = '\252';
	$HF::Encode::quotearray[171] = '\253';
	$HF::Encode::quotearray[172] = '\254';
	$HF::Encode::quotearray[173] = '\255';
	$HF::Encode::quotearray[174] = '\256';
	$HF::Encode::quotearray[175] = '\257';
	$HF::Encode::quotearray[176] = '\260';
	$HF::Encode::quotearray[177] = '\261';
	$HF::Encode::quotearray[178] = '\262';
	$HF::Encode::quotearray[179] = '\263';
	$HF::Encode::quotearray[180] = '\264';
	$HF::Encode::quotearray[181] = '\265';
	$HF::Encode::quotearray[182] = '\266';
	$HF::Encode::quotearray[183] = '\267';
	$HF::Encode::quotearray[184] = '\270';
	$HF::Encode::quotearray[185] = '\271';
	$HF::Encode::quotearray[186] = '\272';
	$HF::Encode::quotearray[187] = '\273';
	$HF::Encode::quotearray[188] = '\274';
	$HF::Encode::quotearray[189] = '\275';
	$HF::Encode::quotearray[190] = '\276';
	$HF::Encode::quotearray[191] = '\277';
	$HF::Encode::quotearray[192] = '\300';
	$HF::Encode::quotearray[193] = '\301';
	$HF::Encode::quotearray[194] = '\302';
	$HF::Encode::quotearray[195] = '\303';
	$HF::Encode::quotearray[196] = '\304';
	$HF::Encode::quotearray[197] = '\305';
	$HF::Encode::quotearray[198] = '\306';
	$HF::Encode::quotearray[199] = '\307';
	$HF::Encode::quotearray[200] = '\310';
	$HF::Encode::quotearray[201] = '\311';
	$HF::Encode::quotearray[202] = '\312';
	$HF::Encode::quotearray[203] = '\313';
	$HF::Encode::quotearray[204] = '\314';
	$HF::Encode::quotearray[205] = '\315';
	$HF::Encode::quotearray[206] = '\316';
	$HF::Encode::quotearray[207] = '\317';
	$HF::Encode::quotearray[208] = '\320';
	$HF::Encode::quotearray[209] = '\321';
	$HF::Encode::quotearray[210] = '\322';
	$HF::Encode::quotearray[211] = '\323';
	$HF::Encode::quotearray[212] = '\324';
	$HF::Encode::quotearray[213] = '\325';
	$HF::Encode::quotearray[214] = '\326';
	$HF::Encode::quotearray[215] = '\327';
	$HF::Encode::quotearray[216] = '\330';
	$HF::Encode::quotearray[217] = '\331';
	$HF::Encode::quotearray[218] = '\332';
	$HF::Encode::quotearray[219] = '\333';
	$HF::Encode::quotearray[220] = '\334';
	$HF::Encode::quotearray[221] = '\335';
	$HF::Encode::quotearray[222] = '\336';
	$HF::Encode::quotearray[223] = '\337';
	$HF::Encode::quotearray[224] = '\340';
	$HF::Encode::quotearray[225] = '\341';
	$HF::Encode::quotearray[226] = '\342';
	$HF::Encode::quotearray[227] = '\343';
	$HF::Encode::quotearray[228] = '\344';
	$HF::Encode::quotearray[229] = '\345';
	$HF::Encode::quotearray[230] = '\346';
	$HF::Encode::quotearray[231] = '\347';
	$HF::Encode::quotearray[232] = '\350';
	$HF::Encode::quotearray[233] = '\351';
	$HF::Encode::quotearray[234] = '\352';
	$HF::Encode::quotearray[235] = '\353';
	$HF::Encode::quotearray[236] = '\354';
	$HF::Encode::quotearray[237] = '\355';
	$HF::Encode::quotearray[238] = '\356';
	$HF::Encode::quotearray[239] = '\357';
	$HF::Encode::quotearray[240] = '\360';
	$HF::Encode::quotearray[241] = '\361';
	$HF::Encode::quotearray[242] = '\362';
	$HF::Encode::quotearray[243] = '\363';
	$HF::Encode::quotearray[244] = '\364';
	$HF::Encode::quotearray[245] = '\365';
	$HF::Encode::quotearray[246] = '\366';
	$HF::Encode::quotearray[247] = '\367';
	$HF::Encode::quotearray[248] = '\370';
	$HF::Encode::quotearray[249] = '\371';
	$HF::Encode::quotearray[250] = '\372';
	$HF::Encode::quotearray[251] = '\373';
	$HF::Encode::quotearray[252] = '\374';
	$HF::Encode::quotearray[253] = '\375';
	$HF::Encode::quotearray[254] = '\376';
	$HF::Encode::quotearray[255] = '\377';
}

sub encode {

	my $self = shift;
	my $arg = shift;

#	$arg =~ s/([^!-\[\]-~])/$HF::Encode::quotearray[ord ($1)]/ge;
	$arg =~ s/([^\041\050-\077\101-\133\135-\137\141-\176])/$HF::Encode::quotearray[ord ($1)]/ge;	# expanded to pass perl eval

	return ($arg);
}

sub decode {

	my $self = shift;
	my $arg = shift;

	$arg =~ s/\\(\d{3})/chr (oct ($1))/ge;

	return ($arg);
}

BEGIN {

	&encodesetup;
}

1;
