#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

package HF::Marshal;
use strict;

sub marshal {

	my $payload = shift;

	return (sprintf ("%15d%s", length ($payload), $payload));
}

sub unmarshal {

	my $sourcefh = shift;

	my $size;
	my $payload;

	read ($sourcefh, $size, 15);
	$size += 0;

	if ($size == 0) {
		return ('');
	}

	read ($sourcefh, $payload, $size);
	return ($payload);
}

1;
