#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

$HF::Globals::hfver = '@@@ HFVER @@@';

# -----

my $opt_b;
my $filecontents;
my $thisblock;

if ($ARGV[0] eq '-b') {
	$opt_b = 1;
	shift (@ARGV);
} else {
	$opt_b = 0;
}

{
	local ($/);
	while ($filecontents = <>) {
		if ($opt_b == 1) {
			while ($thisblock = substr ($filecontents, 0, 70, ''), length ($thisblock) > 0) {
				# XXX doesn't actually work because $'a\000b' in bash produces
				# XXX "a" only, not NUL or "b"
				print &HF::Misc::bashencode ($thisblock) . "\n";
			}
		} else {
			print HF::Encode->encode ($filecontents);
		}
	}
}

exit (0);
