#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

if [ "${1:-}" = '-k' ]
then
	OPTK='-k'
	shift
else
	OPTK=''
fi

if [ -z "${1:-}" ]
then
	set -- '.'
fi

for i
do
	/@@@ HFTOP @@@/bin/sl $OPTK "$i" | md5sum | awk '{print $1}' > /tmp/sl-sum.$$
	if [ $# -le 1 ]
	then
		echo "$(< /tmp/sl-sum.$$)"
	else
		echo "$(< /tmp/sl-sum.$$)"$'\t'"$i"
	fi
done

rm /tmp/sl-sum.$$
