#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

# pgrep for gnome-session designed for Ubuntu 10 and Ubuntu 12.

if [ "${1:-}" = '-w' ]
then
	oe ix bash << 'EOF'
PIDS=`pgrep gnome-session || :`

if [ -n "$PIDS" ]
then
	ps u -p $PIDS
	kill $PIDS
	sleep 5
	kill -9 $PIDS 2> /dev/null || :
	echo "
Processes killed."
fi
EOF
else
	oe ix bash << 'EOF'
PIDS=`pgrep gnome-session || :`

if [ -n "$PIDS" ]
then
	ps u -p $PIDS
	echo "
No action taken, use -w to kill these processes."
fi
EOF
fi
