#!/usr/bin/perl

#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

#
#  Usage:
#
#	echo -e 'username\tUser Name\tpassword' | ./password-cards.pl > cards.tex
#

print q{\documentclass[12pt,twocolumn]{article}

\usepackage[rmargin=0.5in,lmargin=1.5in,tmargin=0.5in,bmargin=0.5in]{geometry}
\pagestyle{empty}

\begin{document}

};

while (<>) {

	$line = $_;
	chop ($line);
	($username, $humanname, $password, $junk) = split (/\t/, $line);
	$password =~ s/[%&^<>{}#]/\\&1/g;

	print q{\begin{tabular}{|c|}
\hline \\\\
\large \ \ \ Computer Account\ \ \  \\\\
\small } . $humanname . q{ \\\\
Username: } . $username . q{ \\\\
Password: } . $password . q{ \\\\ 
\\\\ \hline
\end{tabular}

\vskip0.3in

};
};

print q{\end{document}
};
