#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

ps_OTHERS := \
	ps/GNUmakefile \
	ps/module.mk \
	ps/dataflow.idraw \
	ps/factory2.idraw \
	ps/Notes \
	ps/wv2.5inchH.ai

ps_SOURCES := \
	$(ps_OTHERS)

ps_BASH_TESTME :=

ps_PERL_TESTME :=

ps_BASH_RESULTS :=

ps_PERL_RESULTS :=

ps_RESULTS := \
	$(ps_BASH_RESULTS) \
	$(ps_PERL_RESULTS)

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
ps/md5:
	cat $(ps_SOURCES) | md5sum | awk '{print $$1}' > ps/md5

.PHONY: build_ps
build_ps: $(ps_RESULTS) ps/md5 ## Build ps

.PHONY: clean_ps
clean_ps: ## Clean ps
	rm -f $(strip $(ps_RESULTS) ps/md5)

.PHONY: install_ps
install_ps: installstep1 $(ps_RESULTS) ps/md5 ## Install ps

