#!/usr/bin/perl

#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

use Socket;
use Carp;

$socketname = shift;

if ($socketname eq "") {
	die "Usage: makesocket socket-name\n";
}

if (-e $socketname) {
	unlink ($socketname) || die "$!";
}
socket (SOCKETFH, &main::PF_UNIX, &main::SOCK_STREAM, 0) || die "$!";
bind (SOCKETFH, &main::sockaddr_un ($socketname)) || die "$!";
close (SOCKETFH);
