#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

tests_SOURCES := \
	tests/module.mk \
	tests/GNUmakefile \
	tests/bridge.hflayers \
	tests/eight.hflayers \
	tests/five.hfhosts \
	tests/five-pull.hfhosts \
	tests/five-pull.hflayers \
	tests/five_s.hflayers \
	tests/five_ssh.hfhosts \
	tests/five_ssh.hflayers \
	tests/four_checksum.hfhosts \
	tests/four_checksum.hflayers \
	tests/four_checksum-pull.hfhosts \
	tests/four_checksum-pull.hflayers \
	tests/four_checksum_ssh.hfhosts \
	tests/four_checksum_ssh.hflayers \
	tests/four.hfhosts \
	tests/four.hflayers \
	tests/four-pull.hfhosts \
	tests/four-pull.hflayers \
	tests/four_pull_ssh.hfhosts \
	tests/four_pull_ssh.hflayers \
	tests/four_ssh.hfhosts \
	tests/four_ssh.hflayers \
	tests/makesocket.pl \
	tests/mkt_bridge.pl \
	tests/mkt_hflog_rsync.pl \
	tests/mkt_names.pl \
	tests/mkt_rand_hardlinks.pl \
	tests/mkt_random_tree.pl \
	tests/mkt_treat_3.pl \
	tests/mkt_treatment_tree.pl \
	tests/mkt_tree.pl \
	tests/mkt_wantbelow.pl \
	tests/ping.sh \
	tests/pong.sh \
	tests/stlstream.hflayers \
	tests/test-aborts \
	tests/test-bridge \
	tests/test-compare.hflayers \
	tests/test-components \
	tests/test-database \
	tests/test-does-it-run \
	tests/test-encode.pl \
	tests/test-everything \
	tests/test-filters \
	tests/test-filters.hflayers \
	tests/test-following-symlinks \
	tests/test-ftgroveler.pl \
	tests/test-ftwstream.pl \
	tests/test-gen \
	tests/test-globstream \
	tests/test-hflayers.pl \
	tests/test-hflog-cC \
	tests/test-hflog-rsync \
	tests/test-joinpaths.pl \
	tests/test-marshal.pl \
	tests/test-nullstream \
	tests/test-oe \
	tests/test-oe-dosave \
	tests/test-oe-files-to-tar \
	tests/test-oh \
	tests/test-oh-large \
	tests/test-omar-hg \
	tests/test-path_is_clean.pl \
	tests/test-propagation \
	tests/test-propagation-complex.sh \
	tests/test-propagation-pull \
	tests/test-propagation-pull-ssh \
	tests/test-propagation-ssh \
	tests/test-rand-hardlinks \
	tests/test-random-tree \
	tests/test-random-tree-10-artifact \
	tests/test_random_tree.hfhosts \
	tests/test_random_tree.hflayers \
	tests/test-random-tree-profile \
	tests/test-skips \
	tests/test-skips.hflayers \
	tests/test-source-delete \
	tests/test-sl-b \
	tests/test-stlstream \
	tests/test-treatments \
	tests/test-treatments-2 \
	tests/test-treatments-2.hflayers \
	tests/test-treatments-3 \
	tests/test-treatments-3.hflayers \
	tests/test-treatments-3-sr.hflayers \
	tests/test-treatments.hflayers \
	tests/test-wantbelow \
	tests/test-wantbelow.hflayers \
	tests/three.hfhosts \
	tests/three.hflayers \
	tests/vmlinux-2.2.16-3

tests_BASH_TESTME := \
	tests/ping.sh \
	tests/pong.sh \
	tests/test-bridge \
	tests/test-components \
	tests/test-database \
	tests/test-does-it-run \
	tests/test-everything \
	tests/test-filters \
	tests/test-following-symlinks \
	tests/test-gen \
	tests/test-hflog-cC \
	tests/test-hflog-rsync \
	tests/test-oe \
	tests/test-oe-dosave \
	tests/test-oh \
	tests/test-oh-large \
	tests/test-omar-hg \
	tests/test-propagation \
	tests/test-propagation-complex.sh \
	tests/test-propagation-pull \
	tests/test-propagation-pull-ssh \
	tests/test-propagation-ssh \
	tests/test-rand-hardlinks \
	tests/test-random-tree \
	tests/test-random-tree-10-artifact \
	tests/test-skips \
	tests/test-source-delete \
	tests/test-sl-b \
	tests/test-stlstream \
	tests/test-treatments \
	tests/test-treatments-2 \
	tests/test-treatments-3 \
	tests/test-wantbelow

tests_PERL_TESTME := \
	tests/bridge.hflayers \
	tests/eight.hflayers \
	tests/five.hfhosts \
	tests/five-pull.hfhosts \
	tests/five-pull.hflayers \
	tests/five_s.hflayers \
	tests/five_ssh.hfhosts \
	tests/five_ssh.hflayers \
	tests/four_checksum.hfhosts \
	tests/four_checksum.hflayers \
	tests/four_checksum-pull.hfhosts \
	tests/four_checksum-pull.hflayers \
	tests/four_checksum_ssh.hfhosts \
	tests/four_checksum_ssh.hflayers \
	tests/four.hfhosts \
	tests/four.hflayers \
	tests/four-pull.hfhosts \
	tests/four-pull.hflayers \
	tests/four_pull_ssh.hfhosts \
	tests/four_pull_ssh.hflayers \
	tests/four_ssh.hfhosts \
	tests/four_ssh.hflayers \
	tests/makesocket.pl \
	tests/mkt_treat_3.pl \
	tests/stlstream.hflayers \
	tests/test-compare.hflayers \
	tests/test-filters.hflayers \
	tests/test_random_tree.hfhosts \
	tests/test_random_tree.hflayers \
	tests/test-skips.hflayers \
	tests/test-treatments-2.hflayers \
	tests/test-treatments-3.hflayers \
	tests/test-treatments-3-sr.hflayers \
	tests/test-treatments.hflayers \
	tests/three.hfhosts \
	tests/three.hflayers

tests_BASH_RESULTS :=

tests_PERL_RESULTS := \
	tests/mkt_bridge \
	tests/mkt_hflog_rsync \
	tests/mkt_names \
	tests/mkt_rand_hardlinks \
	tests/mkt_random_tree \
	tests/mkt_treatment_tree \
	tests/mkt_tree \
	tests/mkt_wantbelow \
	tests/test-encode \
	tests/test-ftgroveler \
	tests/test-ftwstream \
	tests/test-hflayers \
	tests/test-joinpaths \
	tests/test-marshal \
	tests/test-path_is_clean

tests_RESULTS := \
	$(tests_BASH_RESULTS) \
	$(tests_PERL_RESULTS)

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
tests/md5:
	cat $(tests_SOURCES) | md5sum | awk '{print $$1}' > tests/md5

tests/mkt_bridge: tests/mkt_bridge.pl
	echo "#!/usr/bin/perl" > tests/mkt_bridge
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		< tests/mkt_bridge.pl >> tests/mkt_bridge
	chmod +x tests/mkt_bridge

tests/mkt_hflog_rsync: tests/mkt_hflog_rsync.pl
	echo "#!/usr/bin/perl" > tests/mkt_hflog_rsync
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		< tests/mkt_hflog_rsync.pl >> tests/mkt_hflog_rsync
	chmod +x tests/mkt_hflog_rsync

tests/mkt_names: tests/mkt_names.pl
	echo "#!/usr/bin/perl" > tests/mkt_names
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		< tests/mkt_names.pl >> tests/mkt_names
	chmod +x tests/mkt_names

tests/mkt_tree: tests/mkt_tree.pl
	echo "#!/usr/bin/perl" > tests/mkt_tree
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		< tests/mkt_tree.pl >> tests/mkt_tree
	chmod +x tests/mkt_tree

tests/mkt_random_tree: tests/mkt_random_tree.pl
	echo "#!/usr/bin/perl" > tests/mkt_random_tree
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		< tests/mkt_random_tree.pl >> tests/mkt_random_tree
	chmod +x tests/mkt_random_tree

tests/mkt_treatment_tree: tests/mkt_treatment_tree.pl
	echo "#!/usr/bin/perl" > tests/mkt_treatment_tree
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		< tests/mkt_treatment_tree.pl >> tests/mkt_treatment_tree
	chmod +x tests/mkt_treatment_tree

tests/mkt_rand_hardlinks: tests/mkt_rand_hardlinks.pl
	echo "#!/usr/bin/perl" > tests/mkt_rand_hardlinks
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		< tests/mkt_rand_hardlinks.pl >> tests/mkt_rand_hardlinks
	chmod +x tests/mkt_rand_hardlinks

tests/mkt_wantbelow: tests/mkt_wantbelow.pl
	echo "#!/usr/bin/perl" > tests/mkt_wantbelow
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		< tests/mkt_wantbelow.pl >> tests/mkt_wantbelow
	chmod +x tests/mkt_wantbelow

tests/test-encode: tests/test-encode.pl
	echo "#!/usr/bin/perl" > tests/test-encode
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		< tests/test-encode.pl >> tests/test-encode
	chmod +x tests/test-encode

tests/test-ftgroveler: tests/test-ftgroveler.pl
	echo "#!/usr/bin/perl" > tests/test-ftgroveler
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		< tests/test-ftgroveler.pl >> tests/test-ftgroveler
	chmod +x tests/test-ftgroveler

tests/test-ftwstream: tests/test-ftwstream.pl
	echo "#!/usr/bin/perl" > tests/test-ftwstream
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		< tests/test-ftwstream.pl >> tests/test-ftwstream
	chmod +x tests/test-ftwstream

tests/test-hflayers: tests/test-hflayers.pl
	echo "#!/usr/bin/perl" > tests/test-hflayers
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		< tests/test-hflayers.pl >> tests/test-hflayers
	chmod +x tests/test-hflayers

tests/test-marshal: tests/test-marshal.pl
	echo "#!/usr/bin/perl" > tests/test-marshal
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		< tests/test-marshal.pl >> tests/test-marshal
	chmod +x tests/test-marshal

tests/test-joinpaths: tests/test-joinpaths.pl
	echo "#!/usr/bin/perl" > tests/test-joinpaths
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		< tests/test-joinpaths.pl >> tests/test-joinpaths
	chmod +x tests/test-joinpaths

tests/test-path_is_clean: tests/test-path_is_clean.pl
	echo "#!/usr/bin/perl" > tests/test-path_is_clean
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		< tests/test-path_is_clean.pl >> tests/test-path_is_clean
	chmod +x tests/test-path_is_clean

.PHONY: build_tests
build_tests: $(tests_RESULTS) tests/md5 ## Build tests

.PHONY: clean_tests
clean_tests: ## Clean tests
	chmod -f 755 tests/t_names{,2}/unreadabledir tests/t_glob_?/unreadabledir || :
	rm -rf $(strip tests/t_* $(tests_RESULTS) tests/test-everything.log tests/test-propagation-pl-1.log tests/test-propagation-pl-2.log tests/md5 tests/nytprof*)

.PHONY: profile
profile: clean_profile ## Profile
	(cd tests ; ./test-random-tree-profile 3)

.PHONY: clean_profile
clean_profile: ## Clean profile data
	rm -rf $(strip tests/nytprof*)

.PHONY: install_tests
install_tests: installstep1 $(tests_RESULTS) tests/md5 ## Install tests

ORPHAN_BASH_TESTME := \
	build-site/apt-get-packages/oe-packages-diff \
	build-site/apt-get-packages/precise-12/client-networked-precise.sh \
	build-site/apt-get-packages/precise-12/client-standalone-precise.sh \
	build-site/apt-get-packages/precise-12/client-standalone-precise-smaller.sh \
	build-site/apt-get-packages/precise-12/INSTALL-MYSQL.sh \
	build-site/apt-get-packages/precise-12/INSTALL-RDB.sh \
	build-site/pull-times.sh \
	build-site/s1.sh \
	build-site/s2.sh \
	build-site/s3.sh \
	build-site/s4.sh \
	build-site/s5.sh \
	build-site/s6.sh \
	build-site/s8.sh \
	configure \
	passwords/get-usernames.sh \
	passwords/README.sh \
	passwords/report-highestuidgid.sh \
	PREBUILD/Ubuntu_12.04.sh

ORPHAN_PERL_TESTME := \
	build-site/desktop-virt.hfhosts \
	build-site/HOW-live-perl-in-hflayers \
	build-site/s1.hflayers \
	build-site/s2.hflayers \
	build-site/server-hosted.hfhosts \
	build-site/server-virt.hfhosts \
	build-site/tolocaltime.pl \
	passwords/add-passwords.pl \
	passwords/password-cards.pl

.PHONY: test
test: ## Run all tests
	(set -e ; for i in $(ALLBASHRESULTS) $(ALLBASHTESTME) $(ORPHAN_BASH_TESTME) ; do echo syntax check $$i ; bash -n $$i ; done) |& tee tests/test-everything.log
	(set -e ; for i in $(ALLPERLRESULTS) $(ALLPERLTESTME) $(ORPHAN_PERL_TESTME) ; do perl -c $$i ; done) |& tee -a tests/test-everything.log
	(set -e ; for i in $(ALLPOD) ; do podchecker $$i ; done) |& tee -a tests/test-everything.log
	cd tests ; ./test-everything |& tee -a test-everything.log
