
#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

use lib '/@@@ USE LIB @@@';
use HF::HF;

# make HF::Report->report work
$HF::Globals::islocal = 1;
$HF::Globals::verbosity = 20;

$samples = [

	['/', '/bar'],		'/bar',
	['/', 'bar'],		'/bar',
	['/foo', 'bar'],	'/foo/bar',
	['foo', 'bar'],		'foo/bar',
	['/foo', '/bar'],	'/foo/bar',
	['/', '/'],		'/',
	['', ''],		'/',
	['a', 'b', 'c'],	'a/b/c',
	['', 'bar'],		'/bar',
	['/foo/', 'bar/'],	'/foo/bar'
];

printf ("%-30s %-20s %-20s\n\n", 'input', 'returned', 'desired');
for ($i = shift (@{$samples}), $j = shift (@{$samples});
	defined ($i);
	$i = shift (@{$samples}), $j = shift (@{$samples})) {

	$k = HF::Misc::joinpaths (@{$i});
	printf ("%-30s %-20s %-20s\n",
		"'" . join ("', '", @{$i}) . "'",
		"'" . $k . "'",
		"'" . $j . "'");

	if ($k ne $j) {
		die "FAILED\n";
	}
}
