hfdist /tmp/a /tmp/b > /tmp/hfdist_stdout.$$
STATUS=$?
if [ $STATUS -ne 0 ]
then
    echo "ERROR hfdist exit status is $STATUS" 1>&2
    exit $STATUS
fi

if ! grep '^HFDIST_[A-Z_]\+=[0-9]\+$' /tmp/hfdist_stdout.$$ > /tmp/hfdist_stdout2.$$
then
    echo "ERROR no HFDIST_ variables in hfdist stdout" 1>&2
    exit 1
fi

HFDIST_VARS=$(< /tmp/hfdist_stdout2.$$)
eval "$HFDIST_VARS"
rm /tmp/hfdist_stdout.$$ /tmp/hfdist_stdout2.$$

if [ "${HFDIST_FAIL_TOTAL:?FATAL HFDIST_FAIL_TOTAL env variable unset}" -ne 0 ]
then
    echo "ERROR HFDIST_FAIL_TOTAL is $HFDIST_FAIL_TOTAL"
    exit 1
fi
echo "PROGRESS diff total ${HFDIST_DIFF_TOTAL:?FATAL HFDIST_DIFF_TOTAL env variable unset}" 1>&2
