#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

treat_OTHERS := \
	treat/GNUmakefile \
	treat/module.mk

treat_SOURCES := \
	treat/test-trtab2 \
	treat/trtab2.pl \
	$(treat_OTHERS)

treat_BASH_TESTME := \
	treat/test-trtab2

treat_PERL_TESTME := \
	treat/trtab2.pl

treat_BASH_RESULTS :=

treat_PERL_RESULTS :=

treat_RESULTS := \
	$(treat_BASH_RESULTS) \
	$(treat_PERL_RESULTS) \
	treat/0-inverse.tex \
	treat/0-normal.tex \
	treat/101-inverse.tex \
	treat/101-normal.tex \
	treat/102-inverse.tex \
	treat/102-normal.tex \
	treat/103-inverse.tex \
	treat/103-normal.tex \
	treat/104-inverse.tex \
	treat/104-normal.tex \
	treat/105-inverse.tex \
	treat/105-normal.tex \
	treat/106-inverse.tex \
	treat/106-normal.tex \
	treat/107-inverse.tex \
	treat/107-normal.tex \
	treat/109-inverse.tex \
	treat/109-normal.tex \
	treat/113-inverse.tex \
	treat/113-normal.tex

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
treat/md5:
	cat $(treat_SOURCES) | md5sum | awk '{print $$1}' > treat/md5

treat/0-inverse.tex treat/0-normal.tex treat/101-inverse.tex treat/101-normal.tex treat/102-inverse.tex treat/102-normal.tex treat/103-inverse.tex treat/103-normal.tex treat/104-inverse.tex treat/104-normal.tex treat/105-inverse.tex treat/105-normal.tex treat/106-inverse.tex treat/106-normal.tex treat/107-inverse.tex treat/107-normal.tex treat/109-inverse.tex treat/109-normal.tex treat/113-inverse.tex treat/113-normal.tex: treat/trtab2.pl
	cd treat && ./trtab2.pl

.PHONY: build_treat
build_treat: $(treat_RESULTS) treat/md5 ## Build treat

.PHONY: clean_treat
clean_treat: ## Clean treat
	rm -rf $(strip treat/t_* treat/*.sl $(treat_RESULTS) treat/0*.tex treat/1*.tex treat/2*.tex treat/test-trtab2-inverse.hflayers treat/test-trtab2-normal.hflayers treat/mkt_trtab2.pl treat/md5)

.PHONY: install_treat
install_treat: installstep1 $(treat_RESULTS) treat/md5 ## Install treat


